Index: java/main/src/main/java/com/framsticks/communication/Address.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/Address.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/communication/Address.java	(revision 97)
@@ -0,0 +1,57 @@
+package com.framsticks.communication;
+
+import java.util.regex.Matcher;
+import java.util.regex.Pattern;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.FramsticksException;
+
+@FramsClassAnnotation
+public class Address {
+
+	private final static Pattern pattern = Pattern.compile("^([^:]*)(:([0-9]+))?$");
+
+	protected final String hostName;
+	protected final int port;
+
+	/**
+	 * @param hostName
+	 * @param port
+	 */
+	public Address(String hostName, int port) {
+		this.hostName = hostName;
+		this.port = port;
+	}
+
+	public Address(String address) {
+		Matcher matcher = pattern.matcher(address);
+		if (!matcher.matches()) {
+			throw new FramsticksException().msg("invalid address").arg("address", address);
+		}
+		hostName = matcher.group(1);
+		port = matcher.group(3) != null ? Integer.parseInt(matcher.group(3)) : 9009;
+	}
+
+	@Override
+	public String toString() {
+		return hostName + ":" + port;
+	}
+
+	/**
+	 * @return the hostName
+	 */
+	@ParamAnnotation
+	public String getHostName() {
+		return hostName;
+	}
+
+	/**
+	 * @return the port
+	 */
+	@ParamAnnotation
+	public int getPort() {
+		return port;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java	(revision 97)
@@ -0,0 +1,398 @@
+package com.framsticks.communication;
+
+import com.framsticks.communication.queries.ApplicationRequest;
+import com.framsticks.communication.queries.ProtocolRequest;
+import com.framsticks.communication.queries.RegistrationRequest;
+import com.framsticks.communication.queries.UseRequest;
+import com.framsticks.communication.queries.VersionRequest;
+import com.framsticks.communication.util.LoggingStateCallback;
+import com.framsticks.params.ListSource;
+import com.framsticks.util.*;
+import com.framsticks.util.dispatching.AtOnceDispatcher;
+import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.JoinableState;
+import com.framsticks.util.lang.Pair;
+import com.framsticks.util.lang.Strings;
+
+import org.apache.log4j.Logger;
+
+import java.util.*;
+import java.util.regex.Matcher;
+import com.framsticks.util.dispatching.RunAt;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public class ClientSideManagedConnection extends ManagedConnection {
+
+	private final static Logger log = Logger.getLogger(ClientSideManagedConnection.class);
+
+	protected final Map<String, Subscription<?>> subscriptions = new HashMap<>();
+
+	private final List<Runnable> applicationRequestsBuffer = new LinkedList<>();
+	private boolean isHandshakeDone = false;
+
+	/**
+	 * @return the requestedVersion
+	 */
+	public int getRequestedVersion() {
+		return requestedVersion;
+	}
+
+	/**
+	 * @param requestedVersion the requestedVersion to set
+	 */
+	public void setRequestedVersion(int requestedVersion) {
+		this.requestedVersion = requestedVersion;
+	}
+
+	protected int requestedVersion = 4;
+
+	public ClientSideManagedConnection() {
+		setDescription("client connection");
+		protocolVersion = -1;
+	}
+
+
+	private static abstract class InboundMessage {
+		protected String currentFilePath;
+		protected List<String> currentFileContent;
+		protected final List<File> files = new ArrayList<File>();
+
+		public abstract void eof();
+
+		protected void initCurrentFile(String path) {
+			currentFileContent = new LinkedList<String>();
+			currentFilePath = path;
+		}
+
+		protected void finishCurrentFile() {
+			if (currentFileContent == null) {
+				return;
+			}
+			files.add(new File(currentFilePath, new ListSource(currentFileContent)));
+			currentFilePath = null;
+			currentFileContent = null;
+		}
+
+		public abstract void startFile(String path);
+
+		public final void addLine(String line) {
+			assert line != null;
+			assert currentFileContent != null;
+			currentFileContent.add(line);
+		}
+
+		public List<File> getFiles() {
+			return files;
+		}
+	}
+
+	private static class EventFire extends InboundMessage {
+		public final Subscription<?> subscription;
+
+		private EventFire(Subscription<?> subscription) {
+			this.subscription = subscription;
+		}
+
+		public void startFile(String path) {
+			assert path == null;
+			initCurrentFile(null);
+		}
+
+		@Override
+		public void eof() {
+			finishCurrentFile();
+
+			subscription.dispatchCall(getFiles());
+		}
+	}
+
+	private static class SentQuery<C> extends InboundMessage {
+		Request request;
+		ClientSideResponseFuture callback;
+		Dispatcher<C> dispatcher;
+
+		public void startFile(String path) {
+			finishCurrentFile();
+			if (!Strings.notEmpty(path)) {
+				assert request instanceof ApplicationRequest;
+				path = ((ApplicationRequest) request).getPath();
+			}
+			Strings.assureNotEmpty(path);
+			initCurrentFile(path);
+		}
+
+		public void eof() {
+			assert Strings.notEmpty(currentFilePath);
+			finishCurrentFile();
+			//no-operation
+		}
+
+		@Override
+		public String toString() {
+			return request.toString();
+		}
+
+		public void dispatchResponseProcess(final Response response) {
+			Dispatching.dispatchIfNotActive(dispatcher, new RunAt<C>(callback) {
+				@Override
+				protected void runAt() {
+					callback.pass(response);
+				}
+			});
+		}
+	}
+
+	private Map<Integer, SentQuery<?>> queryMap = new HashMap<>();
+
+	private SentQuery<?> currentlySentQuery;
+
+	public void send(ProtocolRequest request, ClientSideResponseFuture callback) {
+		//TODO RunAt
+		sendImplementation(request, AtOnceDispatcher.getInstance(), callback);
+	}
+
+
+
+	public <C> void send(final ApplicationRequest request, final Dispatcher<C> dispatcher, final ClientSideResponseFuture callback) {
+		synchronized (applicationRequestsBuffer) {
+			if (!isHandshakeDone) {
+				applicationRequestsBuffer.add(new Runnable() {
+					@Override
+					public void run() {
+						sendImplementation(request, dispatcher, callback);
+					}
+				});
+				return;
+			}
+		}
+		sendImplementation(request, dispatcher, callback);
+	}
+
+	private <C> void sendImplementation(Request request, Dispatcher<C> dispatcher, ClientSideResponseFuture callback) {
+
+		if (getState().ordinal() > JoinableState.RUNNING.ordinal()) {
+			log.fatal("not connected");
+			return;
+		}
+
+		final SentQuery<C> sentQuery = new SentQuery<C>();
+		sentQuery.request = request;
+		sentQuery.callback = callback;
+		sentQuery.dispatcher = dispatcher;
+
+		senderThread.dispatch(new RunAt<Connection>(callback) {
+			@Override
+			protected void runAt() {
+				Integer id;
+				synchronized (ClientSideManagedConnection.this) {
+
+					while (!(requestIdEnabled || currentlySentQuery == null)) {
+						try {
+							ClientSideManagedConnection.this.wait();
+						} catch (InterruptedException ignored) {
+							break;
+						}
+					}
+					if (requestIdEnabled) {
+						queryMap.put(nextQueryId, sentQuery);
+						id = nextQueryId++;
+					} else {
+						currentlySentQuery = sentQuery;
+						id = null;
+					}
+				}
+				String command = sentQuery.request.getCommand();
+				StringBuilder message = new StringBuilder();
+				message.append(command);
+				if (id != null) {
+					message.append(" ").append(id);
+				}
+				message.append(" ");
+				sentQuery.request.construct(message);
+				String out = message.toString();
+
+				putLine(out);
+				flushOut();
+				log.debug("sending query: " + out);
+
+			}
+		});
+		/*
+		synchronized (this) {
+			log.debug("queueing query: " + query);
+			queryQueue.offer(sentQuery);
+			notifyAll();
+		}
+		 */
+	}
+
+	@Override
+	public String toString() {
+		return "client connection " + address;
+	}
+
+	public <C> void subscribe(final String path, final Dispatcher<C> dispatcher, final SubscriptionCallback<? extends C> callback) {
+		send(new RegistrationRequest().path(path), AtOnceDispatcher.getInstance(), new ClientSideResponseFuture(callback) {
+			@Override
+			protected void processOk(Response response) {
+				assert response.getFiles().isEmpty();
+				Subscription<C> subscription = new Subscription<C>(ClientSideManagedConnection.this, path, response.getComment(), dispatcher);
+				log.debug("registered on event: " + subscription);
+				synchronized (subscriptions) {
+					subscriptions.put(subscription.getRegisteredPath(), subscription);
+				}
+				subscription.setEventCallback(callback.subscribed(subscription));
+				if (subscription.getEventCallback() == null) {
+					log.info("subscription for " + path + " aborted");
+					subscription.unsubscribe(new LoggingStateCallback(log, "abort subscription"));
+				}
+			}
+		});
+	}
+
+	private void sendQueryVersion(final int version, final Future<Void> future) {
+		send(new VersionRequest().version(version), new ClientSideResponseFuture(future) {
+			@Override
+			protected void processOk(Response response) {
+				protocolVersion = version;
+				if (version < requestedVersion) {
+					/** it is an implicit loop here*/
+					sendQueryVersion(version + 1, future);
+					return;
+				}
+				send(new UseRequest().feature("request_id"), new ClientSideResponseFuture(future) {
+
+					@Override
+					protected void processOk(Response response) {
+						requestIdEnabled = true;
+						future.pass(null);
+					}
+				});
+
+			}
+		});
+	}
+
+	private synchronized SentQuery<?> fetchQuery(Integer id, boolean remove) {
+		if (id == null) {
+			if (requestIdEnabled) {
+				return null;
+			}
+			SentQuery<?> result = currentlySentQuery;
+			if (remove) {
+				currentlySentQuery = null;
+				notifyAll();
+			}
+			return result;
+		}
+		if (queryMap.containsKey(id)) {
+			SentQuery<?> result = queryMap.get(id);
+			if (remove) {
+				queryMap.remove(id);
+			}
+			return result;
+		}
+		return null;
+	}
+
+	private int nextQueryId = 0;
+
+	protected void processMessage(InboundMessage inboundMessage) {
+		if (inboundMessage == null) {
+			log.error("failed to use any inbound message");
+			return;
+		}
+
+		String line;
+		while (!(line = getLine()).startsWith("eof")) {
+			// log.debug("line: " + line);
+			inboundMessage.addLine(line);
+		}
+		inboundMessage.eof();
+	}
+
+	protected void processEvent(String rest) {
+		Matcher matcher = Request.EVENT_PATTERN.matcher(rest);
+		if (!matcher.matches()) {
+			log.error("invalid event line: " + rest);
+			return;
+		}
+		Subscription<?> subscription = subscriptions.get(matcher.group(1));
+		if (subscription == null) {
+			log.error("non subscribed event: " + matcher.group(1));
+			return;
+		}
+		EventFire event = new EventFire(subscription);
+		event.startFile(null);
+		processMessage(event);
+	}
+
+	protected void processMessageStartingWith(String line) {
+		try {
+			Pair<CharSequence, CharSequence> command = Request.takeIdentifier(line);
+			if (command.first.equals("event")) {
+				processEvent(command.second.toString());
+				return;
+			}
+			Pair<Integer, CharSequence> rest = takeRequestId(command.second);
+
+			if (command.first.equals("file")) {
+				SentQuery<?> sentQuery = fetchQuery(rest.first, false);
+				sentQuery.startFile(rest.second.toString());
+				processMessage(sentQuery);
+				return;
+			}
+
+			SentQuery<?> sentQuery = fetchQuery(rest.first, true);
+			if (sentQuery == null) {
+				return;
+			}
+			log.debug("parsing response for request " + sentQuery);
+
+			sentQuery.dispatchResponseProcess(new Response(command.first.equals("ok"), rest.second.toString(), sentQuery.getFiles()));
+		} catch (FramsticksException e) {
+			throw new FramsticksException().msg("failed to process message").arg("starting with line", line).cause(e);
+		}
+	}
+
+	protected final ExceptionResultHandler closeOnFailure = new ExceptionResultHandler() {
+
+		@Override
+		public void handle(FramsticksException exception) {
+			interrupt();
+			// finish();
+		}
+	};
+
+	@Override
+	protected void receiverThreadRoutine() {
+		startClientConnection(this);
+
+		sendQueryVersion(1, new FutureHandler<Void>(closeOnFailure) {
+
+			@Override
+			protected void result(Void result) {
+				synchronized (applicationRequestsBuffer) {
+					isHandshakeDone = true;
+					for (Runnable r : applicationRequestsBuffer) {
+						r.run();
+					}
+					applicationRequestsBuffer.clear();
+				}
+			}
+		});
+
+		processInputBatchesUntilClosed();
+	}
+
+	protected void processNextInputBatch() {
+		processMessageStartingWith(getLine());
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/communication/ClientSideRawConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ClientSideRawConnection.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/communication/ClientSideRawConnection.java	(revision 97)
@@ -0,0 +1,37 @@
+package com.framsticks.communication;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.RunAt;
+
+@FramsClassAnnotation
+public class ClientSideRawConnection extends Connection {
+
+	public ClientSideRawConnection() {
+		setDescription("client raw connection");
+	}
+
+	@Override
+	protected void receiverThreadRoutine() {
+		startClientConnection(this);
+
+		processInputBatchesUntilClosed();
+	}
+
+	protected void processNextInputBatch() {
+		getLine();
+	}
+
+	public void send(final String line, ExceptionResultHandler handler) {
+
+		senderThread.dispatch(new RunAt<ClientSideRawConnection>(handler) {
+			@Override
+			protected void runAt() {
+				putLine(line);
+				flushOut();
+			}
+		});
+
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/communication/ClientSideResponseFuture.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ClientSideResponseFuture.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/communication/ClientSideResponseFuture.java	(revision 97)
@@ -0,0 +1,24 @@
+package com.framsticks.communication;
+
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.FutureHandler;
+
+public abstract class ClientSideResponseFuture extends FutureHandler<Response> {
+
+	public ClientSideResponseFuture(ExceptionResultHandler handler) {
+		super(handler);
+	}
+
+	protected abstract void processOk(Response response);
+
+	@Override
+	protected final void result(Response response) {
+		if (response.getOk()) {
+			processOk(response);
+		} else {
+			handle(new FramsticksException().msg("invalid response").arg("comment", response.getComment()));
+		}
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/communication/Connection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 97)
@@ -1,7 +1,12 @@
 package com.framsticks.communication;
 
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.io.Encoding;
-import com.framsticks.util.lang.Pair;
+import com.framsticks.util.lang.Strings;
+
+import org.apache.log4j.Level;
 import org.apache.log4j.Logger;
 import java.io.BufferedReader;
@@ -12,4 +17,7 @@
 import java.net.Socket;
 import java.net.SocketTimeoutException;
+import java.util.Collection;
+import java.util.HashSet;
+import java.util.Set;
 
 import com.framsticks.util.dispatching.AbstractJoinable;
@@ -21,66 +29,61 @@
 import com.framsticks.util.dispatching.RunAt;
 import com.framsticks.util.dispatching.Thread;
-
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
+
+@FramsClassAnnotation
 public abstract class Connection extends AbstractJoinable implements JoinableParent {
 
 	protected final static Logger log = Logger.getLogger(Connection.class);
 
-	protected PrintWriter output = null;
-	protected BufferedReader input = null;
+	private PrintWriter output = null;
+	private BufferedReader input = null;
 
 	protected Socket socket = null;
 
-	public boolean requestIdEnabled = false;
-
-	protected int protocolVersion = -1;
-
-	public String getAddress() {
-		return address;
-	}
-	protected final String address;
-	protected final String description;
+	protected Address address;
+	protected String description = "connection";
 
 	protected final Thread<Connection> senderThread = new Thread<>();
 	protected final Thread<Connection> receiverThread = new Thread<>();
 	protected final JoinableCollection<Thread<Connection>> threads = new JoinableCollection<>();
-
-	protected void setUpThreadNames(String name) {
-	}
+	protected final Set<ConnectionListener> listeners = new HashSet<>();
 
 	/**
 	 *
 	 */
-	public Connection(String address, String description) {
-		this.address = address;
-		this.description = description;
-		threads.setObservableName(address + " connection threads");
+	public Connection() {
 		threads.add(senderThread);
 		threads.add(receiverThread);
 
+	}
+
+	protected void updateNames() {
+		if (address == null) {
+			return;
+		}
 		senderThread.setName(description + " thread " + address + " sender");
 		receiverThread.setName(description + " thread " + address + " receiver");
+		threads.setObservableName(address + " connection threads");
+	}
+
+	public void setDescription(String description) {
+		this.description = description;
+		updateNames();
+	}
+
+	@AutoAppendAnnotation
+	public Connection setAddress(Address address) {
+		this.address = address;
+		updateNames();
+		return this;
+	}
+
+	@ParamAnnotation
+	public Connection setAddress(String address) {
+		return setAddress(new Address(address));
 	}
 
 	public synchronized boolean isConnected() {
 		return socket != null && socket.isConnected();
-	}
-
-
-	// protected static final String ARGUMENT_PATTERN_FRAGMENT = "((?:\\S+)|(?:\\\"[^\"]*\\\"))";
-	// protected static final Pattern REQUEST_ID_ENABLED_PATTERN = Pattern.compile("^\\s*([0-9]+)(?:\\s+" + ARGUMENT_PATTERN_FRAGMENT + ")?$");
-	// protected static final Pattern REQUEST_ID_DISABLED_PATTERN = Pattern.compile("^\\s*" + ARGUMENT_PATTERN_FRAGMENT + "?$");
-
-	// // protected final Pair<String, String> breakLine(String line)
-	// protected final Pair<Integer, String> parseRest(String rest) {
-	// 	Matcher matcher = (requestIdEnabled ? REQUEST_ID_ENABLED_PATTERN : REQUEST_ID_DISABLED_PATTERN).matcher(rest);
-	// 	if (!matcher.matches()) {
-	// 		log.fatal("unmatched first line of input: '" + rest + "'");
-	// 		return null;
-	// 	}
-	// 	return new Pair<Integer, String>(requestIdEnabled ? Integer.parseInt(matcher.group(1)) : null, matcher.group(requestIdEnabled ? 2 : 1));
-	// }
-
-	protected final Pair<Integer, CharSequence> takeRequestId(CharSequence line) {
-		return Request.takeRequestId(requestIdEnabled, line);
 	}
 
@@ -105,5 +108,13 @@
 					++iterator;
 					bufferStart = iterator;
-					return lineBuffer.toString();
+					String line = lineBuffer.toString();
+
+					synchronized (listeners) {
+						for (ConnectionListener l : listeners) {
+							l.connectionIncomming(line);
+						}
+					}
+
+					return line;
 				}
 				final int length = readChars - bufferStart;
@@ -131,7 +142,33 @@
 	}
 
+	protected void putLine(String line) {
+		synchronized (listeners) {
+			for (ConnectionListener l : listeners) {
+				l.connectionOutgoing(line);
+			}
+		}
+		output.println(line);
+	}
+
+	protected void flushOut() {
+		output.flush();
+	}
+
+	protected abstract void processNextInputBatch();
+
+	protected final void processInputBatchesUntilClosed() {
+		while (isRunning() && isConnected()) {
+			try {
+				processNextInputBatch();
+			} catch (Exception e) {
+				log.log(isRunning() ? Level.ERROR : Level.DEBUG, "caught exception: ", e);
+				break;
+			}
+		}
+	}
+
 	protected abstract void receiverThreadRoutine();
 
-
+	// @SuppressWarnings("NN_NAKED_NOTIFY")
 	protected void setupStreams() {
 		try {
@@ -146,12 +183,4 @@
 	}
 
-	/**
-	 * Returns Query associated with query getId.
-	 *
-	 * @return Query associated with query getId.
-	 */
-	public int getProtocolVersion() {
-		return protocolVersion;
-	}
 
 
@@ -187,5 +216,5 @@
 	@Override
 	public String getName() {
-		return description + " " + address;
+		return address != null ? description + " " + address : description;
 	}
 
@@ -194,7 +223,7 @@
 		Dispatching.use(threads, this);
 
-		senderThread.dispatch(new RunAt<Connection>() {
+		senderThread.dispatch(new RunAt<Connection>(ThrowExceptionHandler.getInstance()) {
 			@Override
-			public void run() {
+			protected void runAt() {
 				synchronized (Connection.this) {
 					while (state.equals(JoinableState.RUNNING) && output == null) {
@@ -205,8 +234,10 @@
 		});
 
-		receiverThread.dispatch(new RunAt<Connection>() {
+		receiverThread.dispatch(new RunAt<Connection>(ThrowExceptionHandler.getInstance()) {
 			@Override
-			public void run() {
+			protected void runAt() {
 				receiverThreadRoutine();
+				interrupt();
+				finish();
 			}
 		});
@@ -215,5 +246,4 @@
 	@Override
 	protected void joinableInterrupt() {
-		protocolVersion = -1;
 		Dispatching.drop(threads, this);
 		finish();
@@ -226,3 +256,48 @@
 	}
 
+	protected static void startClientConnection(Connection connection) {
+		while (connection.isRunning() && !connection.isConnected()) {
+			log.debug("connecting to " + connection.address);
+			try {
+				connection.socket = new Socket(connection.getAddressObject().getHostName(), connection.getAddressObject().getPort());
+			} catch (IOException e) {
+				log.info(connection + " failed to connect (retrying): " + e);
+				Dispatching.sleep(0.5);
+			}
+		}
+
+		log.debug(connection + " connected");
+		try {
+			connection.socket.setSoTimeout(500);
+			connection.setupStreams();
+		} catch (Exception e) {
+			throw new FramsticksException().msg("failed to initialize socket").cause(e).arg("connection", connection);
+		}
+	}
+
+	/**
+	 * @return the address
+	 */
+	@ParamAnnotation
+	public String getAddress() {
+		return Strings.toStringNullProof(address, "?");
+	}
+
+	public Address getAddressObject() {
+		return address;
+	}
+
+
+	/**
+	 * @return the listeners
+	 */
+	public Collection<ConnectionListener> getListeners() {
+		return listeners;
+	}
+
+	public static <T extends Connection> T to(T connection, Address address) {
+		connection.setAddress(address);
+		return connection;
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/communication/ConnectionListener.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ConnectionListener.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/communication/ConnectionListener.java	(revision 97)
@@ -0,0 +1,8 @@
+package com.framsticks.communication;
+
+import com.framsticks.util.dispatching.Joinable;
+
+public interface ConnectionListener extends Joinable {
+	public void connectionOutgoing(String line);
+	public void connectionIncomming(String line);
+}
Index: java/main/src/main/java/com/framsticks/communication/ManagedConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ManagedConnection.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/communication/ManagedConnection.java	(revision 97)
@@ -0,0 +1,33 @@
+package com.framsticks.communication;
+
+import com.framsticks.util.lang.Pair;
+
+public abstract class ManagedConnection extends Connection {
+
+	public boolean requestIdEnabled = false;
+
+	protected int protocolVersion = -1;
+
+	public ManagedConnection() {
+	}
+
+	protected final Pair<Integer, CharSequence> takeRequestId(CharSequence line) {
+		return Request.takeRequestId(requestIdEnabled, line);
+	}
+
+	/**
+	 * Returns Query associated with query getId.
+	 *
+	 * @return Query associated with query getId.
+	 */
+	public int getProtocolVersion() {
+		return protocolVersion;
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		protocolVersion = -1;
+		super.joinableInterrupt();
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/communication/RequestHandler.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/RequestHandler.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/communication/RequestHandler.java	(revision 97)
@@ -7,4 +7,4 @@
  */
 public interface RequestHandler {
-	public void handle(ApplicationRequest request, ResponseCallback<?> responseCallback);
+	public void handle(ApplicationRequest request, ServerSideResponseFuture responseCallback);
 }
Index: java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java	(revision 97)
@@ -0,0 +1,130 @@
+package com.framsticks.communication;
+
+import com.framsticks.communication.queries.*;
+import com.framsticks.params.SourceInterface;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.lang.Holder;
+import com.framsticks.util.lang.Pair;
+import com.framsticks.util.lang.Strings;
+
+import org.apache.log4j.Logger;
+
+import java.net.Socket;
+import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public class ServerSideManagedConnection extends ManagedConnection {
+
+	private final static Logger log = Logger.getLogger(ServerSideManagedConnection.class);
+
+	RequestHandler requestHandler;
+
+	public ServerSideManagedConnection(Socket socket, RequestHandler requestHandler) {
+		setAddress(new Address(socket.getInetAddress().getHostAddress(), socket.getPort()));
+		setDescription("server connection");
+		this.socket = socket;
+		this.requestHandler = requestHandler;
+		// socket.setSoTimeout(500);
+		setupStreams();
+	}
+
+
+	protected void processNextInputBatch() {
+		processNextRequest();
+	}
+
+	@Override
+	protected void receiverThreadRoutine() {
+
+		processInputBatchesUntilClosed();
+	}
+
+	protected void handleRequest(Request request, ServerSideResponseFuture responseCallback) {
+		if (request instanceof ApplicationRequest) {
+			requestHandler.handle((ApplicationRequest) request, responseCallback);
+			return;
+		}
+		if (request instanceof ProtocolRequest) {
+			if (request instanceof VersionRequest) {
+				responseCallback.pass(new Response(true, null, null));
+				return;
+			}
+			if (request instanceof UseRequest) {
+				String feature = ((UseRequest)request).getFeature();
+				if (feature.equals("request_id")) {
+					requestIdEnabled = true;
+					responseCallback.pass(new Response(true, null, null));
+					return;
+				}
+				responseCallback.pass(new Response(false, "unknown feature: " + feature, null));
+				return;
+			}
+
+		}
+		log.error("unhandled request: " + request);
+		responseCallback.pass(new Response(false, "unhandled", null));
+	}
+
+	protected final void respond(final Response response, final Integer id) {
+		//TODO TEH: pass it the hosted tree
+		senderThread.dispatch(new RunAt<Connection>(ThrowExceptionHandler.getInstance()) {
+			@Override
+			protected void runAt() {
+				String outId = id != null ? " " + id : "";
+				if (response.getFiles() != null) {
+					for (File f : response.getFiles()) {
+						putLine("file" + outId/* + " " + f.getPath()*/);
+						SourceInterface content = f.getContent();
+						String line;
+						while ((line = content.readLine()) != null) {
+							putLine(line);
+						}
+						putLine("eof");
+					}
+				}
+				StringBuilder statusLine = new StringBuilder();
+				statusLine.append(response.getOk() ? "ok" : "error").append(outId);
+				if (Strings.notEmpty(response.getComment())) {
+					statusLine.append(" \"").append(response.getComment()).append('"');
+				}
+				putLine(statusLine.toString());
+				flushOut();
+			}
+		});
+
+	}
+
+
+	protected void processNextRequest() {
+		final Holder<Integer> id = new Holder<>();
+		final String line = getLine();
+		try {
+			Pair<CharSequence, CharSequence> command = Request.takeIdentifier(line);
+			final Pair<Integer, CharSequence> rest = takeRequestId(command.second);
+			id.set(rest.first);
+
+			final Request request = Request.parse(command.first, rest.second);
+
+			if (log.isTraceEnabled()) {
+				log.trace("read request: " + request);
+			}
+
+			//TODO what to do here?
+			handleRequest(request, new ServerSideResponseFuture() {
+				@Override
+				protected void result(Response response) {
+					respond(response, rest.first);
+				}
+			});
+		} catch (FramsticksException e) {
+			e.arg("id", id.get()).arg("line", line);
+			log.error("error: ", e);
+			respond(new Response(false, "invalid input: " + e.getMsg(), null), id.get());
+			return;
+		}
+
+	}
+}
Index: java/main/src/main/java/com/framsticks/communication/ServerSideResponseFuture.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ServerSideResponseFuture.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/communication/ServerSideResponseFuture.java	(revision 97)
@@ -0,0 +1,16 @@
+package com.framsticks.communication;
+
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.Future;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public abstract class ServerSideResponseFuture extends Future<Response> {
+
+	@Override
+	public final void handle(FramsticksException e) {
+		result(new Response(false, e.getClass().getCanonicalName() + ": " + e.getMsg(), null));
+	}
+
+}
